<template>
  <div class="role-form">
    <div class="role-form__container">
      <div class="role-form__header">
        <h1 class="role-form__title">Add a new role</h1>
        <router-link class="role-form__btn is-back" :to="{ name: 'Home' }"
          >Roles list</router-link
        >
      </div>
      <form class="role-form__form" @submit.prevent="onSubmit">
        <h3 class="role-form__subtitle">Name & describe new role</h3>
        <label>Name</label>
        <input v-model="role.name" type="text" placeholder="Name" />

        <label>Type</label>
        <input v-model="role.type" type="text" placeholder="Type" />

        <label>Description</label>
        <input
          v-model="role.description"
          type="text"
          placeholder="Description"
        />
        <button class="role-form__btn" type="submit">Submit</button>
      </form>
    </div>
  </div>
</template>

<script>
import { v4 as uuidv4 } from "uuid";

export default {
  data() {
    return {
      role: {
        id: "",
        name: "",
        type: "",
        description: "",
        date: "",
        time: "",
        organizer: "",
        created_on: "",
        modified_on: "",
        editable: "",
        active: "",
      },
    };
  },
  methods: {
    onSubmit() {
      const role = {
        ...this.role,
        id: uuidv4(),
        organizer: this.$store.state.user,
        editable: false,
        active: false,
        created_on: new Date(),
      };
      this.$store
        .dispatch("createRole", role)
        .then(() => {
          this.$router.push({
            name: "RoleDetails",
            params: { id: role.id },
          });
        })
        .catch((error) => {
          this.$router.push({
            name: "ErrorDisplay",
            params: { error: error },
          });
        });
    },
  },
};
</script>
